# -*- coding:Utf-8 -*-

import es,usermsg,re
import psyco
psyco.full()

info = es.AddonInfo()
info.name = "colormsglib"
info.version = "1.2"
info.author = "EmbouT"
info.url = "http://forums.mattie.info/cs/forums/viewtopic.php?t=24245"
info.description = "Fourni une méthode pour colorer les message (rouge, bleu, gris, vert, vert clair et orange"

mcolour={0:'none',1:'lightgreen',3:'grey',5:'red',7:'blue'}
icolour={'red':0,'blue':0,'grey':-1,'lightgreen':0,'none':0}
team={1:'grey',2:'red',3:'blue'}
iplayer={1:[],2:[],3:[]}


class ColorMsg():
    def __init__(self,msg):
        self.message = str(msg)
        self.color=0
        self.__formatmesssage()

    # private method
    def __formatmesssage(self):
        # vérifier le message
        # s'assurer que le message commence par un code couleur, sinon mettre celui par défaut
        if not self.message.startswith('#'):self.message = '#default'+self.message

        # si il n'y a pas #team dans le message
        if not self.message.count('#team'):
            ncolor=self.__numbercolor()
            # on vérifie qu'il n'y a pas de couleurs incompatible
            if ncolor in (0,1,3,5,7):
            # sinon on défini la couleur du message
                self.color=icolour[mcolour[ncolor]]
            # si oui, on ne fait rien, la couleur vert clair sera adoptée
        else:
            # s'il y a team, on définira la couleur au moment de l'envoi du message
            self.color=-2

        # On remplace chaque code par celui pris en charge par usermsg
        self.message=re.sub('#team','\3',self.message)
        self.message=re.sub('#green','\4',self.message)
        self.message=re.sub('#default','\1',self.message)
        self.message=re.sub('#orange','\1',self.message)


    # private method
    def __numbercolor(self):
        # en même temps, on remplace les codes couleurs par ceux supportés par es.usermsg
        e=0
        if self.message.count('#lightgreen'):
            e+=1
            self.message=re.sub('#lightgreen','\3',self.message)
        if self.message.count('#grey'):
            e+=3
            self.message=re.sub('#grey','\3',self.message)
        if self.message.count('#red'):
            e+=5
            self.message=re.sub('#red','\3',self.message)
        if self.message.count('#blue'):
            e+=7
            self.message=re.sub('#blue','\3',self.message)
        return e

    #private method
    def __saytext(self,userid,index):
        es.usermsg('create','saytext','saytext')
        es.usermsg('write','byte','saytext',index)
        es.usermsg('write','string','saytext',self.message)
        es.usermsg('write','byte','saytext',1)
        es.usermsg('send','saytext',userid)
        es.usermsg('delete','saytext')

    # public method
    def tell(self,player):
        # vérifier si player est un joueur unique
        try:
            # si oui, on le place dans une liste
            userid = int(player)
            player = [userid]
        except TypeError:
            pass
        t=True if self.color==-2 else False
        # on envoi le message à la liste
        for userid in player:
            if es.exists('userid',userid):
                c=icolour[team[es.getplayerteam(userid)]] if t else self.color
                self.__saytext(userid,c)
            else:
                es.dbgmsg(0,'%s is an invalid userid'%userid)
    # public method
    def msg(self):
        # on vérifie que #team n'est pas dans le message, si oui on met vert clair
        t=True if self.color==-2 else False
        for userid in es.getUseridList():
            c=0 if t else self.color
            self.__saytext(userid,c)


def setcolor(userindex,userteam,oldteam):
    if oldteam>1:
        if userindex in iplayer[oldteam]:iplayer[oldteam].remove(userindex)
        if icolour[team[oldteam]]==userindex:
            if iplayer[oldteam]:
                icolour[team[oldteam]]=iplayer[oldteam][0]
            else:
                icolour[team[oldteam]]=0
    if not userindex in iplayer[userteam]:iplayer[userteam].append(userindex)
    if not icolour[team[userteam]]:icolour[team[userteam]]=userindex



def initialise():
    if es.getplayercount():
        playerlist =es.createplayerlist()
        for userid in playerlist:
            userteam=playerlist[userid]['teamid']
            userindex=playerlist[userid]['index']
            if userteam>1:
                setcolor(userindex,userteam,0)



def player_team(event_var):
    if not int(event_var['disconnect']):
        if int(event_var['team'])>1:
            setcolor(int(event_var['es_userindex']),int(event_var['team']),int(event_var['oldteam']))

es.addons.registerForEvent(__import__(__name__), 'player_team', player_team)

initialise()


